//+------------------------------------------------------------------+
//|                     Shifted Donchian Channel with outside Levels |
//|                       Modified by airquest the 6th of june 2014  |
//+------------------------------------------------------------------+

#property  copyright "Open Source - Give me money by PayPal if you want :)"
#property  link      "airquest@hotmail.com"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 11
#property  indicator_color1  White
#property  indicator_color2  White
#property  indicator_color3  Blue
#property  indicator_color4  DarkGray
#property  indicator_color5  DarkGray
#property  indicator_color6  DarkGray
#property  indicator_color7  DarkGray
#property  indicator_color8  Green
#property  indicator_color9  Green
#property  indicator_color10  Red
#property  indicator_color11  Red

#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1
#property  indicator_width4  1
#property  indicator_width5  1
#property  indicator_width6  1
#property  indicator_width7  1
#property  indicator_width8  1
#property  indicator_width9  1
#property  indicator_width10  1
#property  indicator_width11  1

#property  indicator_style4  STYLE_DOT
#property  indicator_style5  STYLE_DOT
#property  indicator_style6  STYLE_DOT
#property  indicator_style7  STYLE_DOT

//---- indicator parameters
extern int    Periods=52;
extern int    Shift=26;
extern bool   ShowMiddle=True;
extern bool   ShowInside1stLevels=True;
extern double InsideLevel1=33.33;
extern double InsideLevel2=66.66;
extern bool   ShowInside2ndLevels=True;
extern double InsideLevel3=16.66;
extern double InsideLevel4=83.33;
extern bool   ShowOutsideLevels=True;
extern string UserText="UL Levels = H+/L- percentage of HL";
extern double UpperLevel1=33.33;
extern double UpperLevel2=50;
extern double LowerLevel1=33.33;
extern double LowerLevel2=50;

//---- indicator buffers
double     Upper[];
double     Lower[];
double     Middle[];
double     InsideLevel1_Buffer[];
double     InsideLevel2_Buffer[];
double     InsideLevel3_Buffer[];
double     InsideLevel4_Buffer[];
double     UpperLevel1_Buffer[];
double     UpperLevel2_Buffer[];
double     LowerLevel1_Buffer[];
double     LowerLevel2_Buffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE); SetIndexShift(0,Shift);
   SetIndexStyle(1,DRAW_LINE); SetIndexShift(1,Shift);
   if(ShowMiddle)SetIndexStyle(2,DRAW_LINE); else SetIndexStyle(2,DRAW_NONE); SetIndexShift(2,Shift);
   if(ShowInside1stLevels)SetIndexStyle(3,DRAW_LINE); else SetIndexStyle(3,DRAW_NONE); SetIndexShift(3,Shift);
   if(ShowInside1stLevels)SetIndexStyle(4,DRAW_LINE); else SetIndexStyle(4,DRAW_NONE); SetIndexShift(4,Shift);
   if(ShowInside2ndLevels)SetIndexStyle(5,DRAW_LINE); else SetIndexStyle(5,DRAW_NONE); SetIndexShift(5,Shift);
   if(ShowInside2ndLevels)SetIndexStyle(6,DRAW_LINE); else SetIndexStyle(6,DRAW_NONE); SetIndexShift(6,Shift);
   if(ShowOutsideLevels)SetIndexStyle(7,DRAW_LINE); else SetIndexStyle(7,DRAW_NONE); SetIndexShift(7,Shift);
   if(ShowOutsideLevels)SetIndexStyle(8,DRAW_LINE); else SetIndexStyle(8,DRAW_NONE); SetIndexShift(8,Shift);
   if(ShowOutsideLevels)SetIndexStyle(9,DRAW_LINE); else SetIndexStyle(9,DRAW_NONE); SetIndexShift(9,Shift);
   if(ShowOutsideLevels)SetIndexStyle(10,DRAW_LINE); else SetIndexStyle(10,DRAW_NONE); SetIndexShift(10,Shift);

//---- indicator buffers mapping
   SetIndexBuffer(0,Upper);
   SetIndexBuffer(1,Lower);
   SetIndexBuffer(2,Middle);
   SetIndexBuffer(3,InsideLevel1_Buffer);
   SetIndexBuffer(4,InsideLevel2_Buffer);
   SetIndexBuffer(5,InsideLevel3_Buffer);
   SetIndexBuffer(6,InsideLevel4_Buffer);
   SetIndexBuffer(7,UpperLevel1_Buffer);
   SetIndexBuffer(8,UpperLevel2_Buffer);
   SetIndexBuffer(9,LowerLevel1_Buffer);
   SetIndexBuffer(10,LowerLevel2_Buffer);

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Donchian Channel("+Periods+")");
   SetIndexLabel(0,"Upper");
   SetIndexLabel(1,"Lower");
   SetIndexLabel(2,"Middle");
   SetIndexLabel(3,"InsideLevel1");
   SetIndexLabel(4,"InsideLevel2");
   SetIndexLabel(5,"InsideLevel3");
   SetIndexLabel(6,"InsideLevel4");
   SetIndexLabel(7,"UpperLevel1");
   SetIndexLabel(8,"UpperLevel2");
   SetIndexLabel(9,"LowerLevel1");
   SetIndexLabel(10,"LowerLevel2");
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| now do the dance.                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

//---- calculate values
   for(int i=0; i<limit; i++)
   {
      Upper[i]=iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,Periods,i));
      Lower[i]=iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,Periods,i));
      Middle[i]=(Upper[i]+Lower[i])/2;
      InsideLevel1_Buffer[i]= Lower[i]+(Upper[i]-Lower[i])*InsideLevel1/100;
      InsideLevel2_Buffer[i]= Lower[i]+(Upper[i]-Lower[i])*InsideLevel2/100;
      InsideLevel3_Buffer[i]= Lower[i]+(Upper[i]-Lower[i])*InsideLevel3/100;
      InsideLevel4_Buffer[i]= Lower[i]+(Upper[i]-Lower[i])*InsideLevel4/100;
      UpperLevel1_Buffer[i]= Upper[i]+(Upper[i]-Lower[i])*UpperLevel1/100;
      UpperLevel2_Buffer[i]= Upper[i]+(Upper[i]-Lower[i])*UpperLevel2/100;
      LowerLevel1_Buffer[i]= Lower[i]-(Upper[i]-Lower[i])*LowerLevel1/100;
      LowerLevel2_Buffer[i]= Lower[i]-(Upper[i]-Lower[i])*LowerLevel2/100;
   }

   return(0);
  }
